package com.qmth.distributed.print.business.bean.params;

import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import com.qmth.distributed.print.business.enums.ExamCardStatusEnum;
import io.swagger.annotations.ApiModelProperty;
import org.springframework.web.multipart.MultipartFile;

import java.io.Serializable;

/**
 * @Description: 模式4题卡参数
 * @Param:
 * @return:
 * @Author: wangliang
 * @Date: 2025/3/6
 */
public class GenericExamCardModelFourParams implements Serializable {


    @ApiModelProperty(value = "主键id")
    @JsonSerialize(using = ToStringSerializer.class)
    private Long id;

    @ApiModelProperty(value = "题卡标题")
    private String title;

    @ApiModelProperty(value = "考试id")
    @JsonSerialize(using = ToStringSerializer.class)
    private Long examId;

    @ApiModelProperty(value = "课程id")
    @JsonSerialize(using = ToStringSerializer.class)
    private Long courseId;

    @ApiModelProperty(value = "题卡内容附件")
    private MultipartFile contentFile;

    @ApiModelProperty(value = "题卡内容附件md5")
    private String contentMd5;

    @ApiModelProperty(value = "题卡html附件")
    private MultipartFile htmlContentFile;

    @ApiModelProperty(value = "题卡html附件md5")
    private String htmlContentMd5;

    @ApiModelProperty(value = "备注")
    private String remark;

    @ApiModelProperty(value = "题卡规则id")
    @JsonSerialize(using = ToStringSerializer.class)
    private Long cardRuleId;

    @ApiModelProperty(value = "STAGE-暂存，SUBMIT-提交")
    private ExamCardStatusEnum status;

    @ApiModelProperty(value = "题卡纸张大小（A3，8K）")
    private String pageSize;

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public Long getExamId() {
        return examId;
    }

    public void setExamId(Long examId) {
        this.examId = examId;
    }

    public String getTitle() {
        return title;
    }

    public void setTitle(String title) {
        this.title = title;
    }

    public Long getCourseId() {
        return courseId;
    }

    public void setCourseId(Long courseId) {
        this.courseId = courseId;
    }

    public MultipartFile getContentFile() {
        return contentFile;
    }

    public void setContentFile(MultipartFile contentFile) {
        this.contentFile = contentFile;
    }

    public String getContentMd5() {
        return contentMd5;
    }

    public void setContentMd5(String contentMd5) {
        this.contentMd5 = contentMd5;
    }

    public MultipartFile getHtmlContentFile() {
        return htmlContentFile;
    }

    public void setHtmlContentFile(MultipartFile htmlContentFile) {
        this.htmlContentFile = htmlContentFile;
    }

    public String getHtmlContentMd5() {
        return htmlContentMd5;
    }

    public void setHtmlContentMd5(String htmlContentMd5) {
        this.htmlContentMd5 = htmlContentMd5;
    }

    public String getRemark() {
        return remark;
    }

    public void setRemark(String remark) {
        this.remark = remark;
    }

    public Long getCardRuleId() {
        return cardRuleId;
    }

    public void setCardRuleId(Long cardRuleId) {
        this.cardRuleId = cardRuleId;
    }

    public ExamCardStatusEnum getStatus() {
        return status;
    }

    public void setStatus(ExamCardStatusEnum status) {
        this.status = status;
    }

    public String getPageSize() {
        return pageSize;
    }

    public void setPageSize(String pageSize) {
        this.pageSize = pageSize;
    }
}
