package com.qmth.teachcloud.mark.dto.mark.manage;

import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import com.qmth.teachcloud.common.bean.dto.mark.PictureConfig;
import com.qmth.teachcloud.common.enums.mark.MarkProblemType;
import com.qmth.teachcloud.mark.dto.mark.SpecialTagDTO;
import com.qmth.teachcloud.mark.enums.MarkTaskStatus;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class TaskQuestion implements Serializable {

    private static final long serialVersionUID = 3309698238297224617L;
    /**
     * 评卷任务编号
     */
    @JsonSerialize(using = ToStringSerializer.class)
    private Long taskId;

    /**
     * 考生ID
     */
    @JsonSerialize(using = ToStringSerializer.class)
    private Long questionId;


    /**
     * 大题号
     */
    private Integer mainNumber;

    /**
     * 小题号
     */
    private Integer subNumber;
    /**
     * 题型
     */
    private Integer questionType;

    private double intervalScore;

    private double defaultScore;

    private String title;
    private MarkTaskStatus status;

    private Double score;

    private double maxScore;

    private double minScore;

    private boolean uncalculate;

    private List<PictureConfig> picList;

    /**
     * 给分步骤
     */
    private List<TrackDTO> markerTrackList = new ArrayList<>();

    private List<TrackDTO> headerTrackList = new ArrayList<>();

    private List<MarkerScoreDTO> markerList = new ArrayList<>();

    /**
     * 特殊标记列表
     */
    private List<SpecialTagDTO> markerTagList = new ArrayList<>();

    /**
     * 组长特殊标记列表
     */
    private List<SpecialTagDTO> headerTagList = new ArrayList<>();


    /**
     * 评分
     */
    private Double markerScore;

    /**
     * 评卷时间
     */
    private Long markerTime;

    /**
     * 是否自评
     */
    private boolean selfMark;

    /**
     * 是否回评
     */
    private boolean isPrevious;

    /**
     * 是否打回
     */
    private boolean isRejected;

    /**
     * 打回原因
     */
    private String rejectReason;

    /**
     * 打回上次分数
     */
    private String rejectScoreList;

    /**
     * 评卷员登录名
     */
    private String markerName;

    /**
     * 复核时间
     */
    private Date inspectTime;

    /**
     * 错误信息
     */
    private String message;
    /**
     * 是否问题卷
     */
    private boolean isProblem;
    /**
     * 问题卷类型
     */
    private MarkProblemType problemType;
    /**
     * 问题卷类型
     */
    private String problemRemark;

    public Long getTaskId() {
        return taskId;
    }

    public void setTaskId(Long taskId) {
        this.taskId = taskId;
    }

    public Long getQuestionId() {
        return questionId;
    }

    public void setQuestionId(Long questionId) {
        this.questionId = questionId;
    }

    public Integer getMainNumber() {
        return mainNumber;
    }

    public void setMainNumber(Integer mainNumber) {
        this.mainNumber = mainNumber;
    }

    public Integer getSubNumber() {
        return subNumber;
    }

    public void setSubNumber(Integer subNumber) {
        this.subNumber = subNumber;
    }

    public Integer getQuestionType() {
        return questionType;
    }

    public void setQuestionType(Integer questionType) {
        this.questionType = questionType;
    }

    public double getIntervalScore() {
        return intervalScore;
    }

    public void setIntervalScore(double intervalScore) {
        this.intervalScore = intervalScore;
    }

    public double getDefaultScore() {
        return defaultScore;
    }

    public void setDefaultScore(double defaultScore) {
        this.defaultScore = defaultScore;
    }

    public String getTitle() {
        return title;
    }

    public void setTitle(String title) {
        this.title = title;
    }

    public Double getScore() {
        return score;
    }

    public void setScore(Double score) {
        this.score = score;
    }

    public double getMaxScore() {
        return maxScore;
    }

    public void setMaxScore(double maxScore) {
        this.maxScore = maxScore;
    }

    public double getMinScore() {
        return minScore;
    }

    public void setMinScore(double minScore) {
        this.minScore = minScore;
    }

    public boolean isUncalculate() {
        return uncalculate;
    }

    public void setUncalculate(boolean uncalculate) {
        this.uncalculate = uncalculate;
    }

    public List<PictureConfig> getPicList() {
        return picList;
    }

    public void setPicList(List<PictureConfig> picList) {
        this.picList = picList;
    }

    public List<TrackDTO> getMarkerTrackList() {
        return markerTrackList;
    }

    public void setMarkerTrackList(List<TrackDTO> markerTrackList) {
        this.markerTrackList = markerTrackList;
    }

    public void addMarkTrack(TrackDTO track) {
        this.markerTrackList.add(track);
    }

    public List<TrackDTO> getHeaderTrackList() {
        return headerTrackList;
    }

    public void setHeaderTrackList(List<TrackDTO> headerTrackList) {
        this.headerTrackList = headerTrackList;
    }

    public void addHeadTrack(TrackDTO track) {
        this.headerTrackList.add(track);
    }

    public List<SpecialTagDTO> getMarkerTagList() {
        return markerTagList;
    }

    public void setMarkerTagList(List<SpecialTagDTO> markerTagList) {
        this.markerTagList = markerTagList;
    }

    public List<SpecialTagDTO> getHeaderTagList() {
        return headerTagList;
    }

    public void setHeaderTagList(List<SpecialTagDTO> headerTagList) {
        this.headerTagList = headerTagList;
    }

    public Double getMarkerScore() {
        return markerScore;
    }

    public void setMarkerScore(Double markerScore) {
        this.markerScore = markerScore;
    }

    public Long getMarkerTime() {
        return markerTime;
    }

    public void setMarkerTime(Long markerTime) {
        this.markerTime = markerTime;
    }

    public MarkTaskStatus getStatus() {
        return status;
    }

    public void setStatus(MarkTaskStatus status) {
        this.status = status;
    }

    public boolean isSelfMark() {
        return selfMark;
    }

    public void setSelfMark(boolean selfMark) {
        this.selfMark = selfMark;
    }

    public boolean isPrevious() {
        return isPrevious;
    }

    public void setPrevious(boolean previous) {
        isPrevious = previous;
    }

    public boolean isRejected() {
        return isRejected;
    }

    public void setRejected(boolean rejected) {
        isRejected = rejected;
    }

    public String getRejectReason() {
        return rejectReason;
    }

    public void setRejectReason(String rejectReason) {
        this.rejectReason = rejectReason;
    }

    public String getRejectScoreList() {
        return rejectScoreList;
    }

    public void setRejectScoreList(String rejectScoreList) {
        this.rejectScoreList = rejectScoreList;
    }

    public String getMarkerName() {
        return markerName;
    }

    public void setMarkerName(String markerName) {
        this.markerName = markerName;
    }

    public Date getInspectTime() {
        return inspectTime;
    }

    public void setInspectTime(Date inspectTime) {
        this.inspectTime = inspectTime;
    }

    public String getMessage() {
        return message;
    }

    public void setMessage(String message) {
        this.message = message;
    }

    public boolean isProblem() {
        return isProblem;
    }

    public void setProblem(boolean problem) {
        isProblem = problem;
    }

    public MarkProblemType getProblemType() {
        return problemType;
    }

    public void setProblemType(MarkProblemType problemType) {
        this.problemType = problemType;
    }

    public String getProblemRemark() {
        return problemRemark;
    }

    public void setProblemRemark(String problemRemark) {
        this.problemRemark = problemRemark;
    }

    public List<MarkerScoreDTO> getMarkerList() {
        return markerList;
    }

    public void setMarkerList(List<MarkerScoreDTO> markerList) {
        this.markerList = markerList;
    }

    public void addMarkerList(MarkerScoreDTO markerScoreDTO) {
        this.markerList.add(markerScoreDTO);
    }
}
