package com.qmth.teachcloud.mark.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import java.io.Serializable;
import java.util.List;

import com.qmth.teachcloud.mark.dto.mark.manage.TaskQuestion;
import com.qmth.teachcloud.mark.dto.mark.score.SheetUrlDto;
import com.qmth.teachcloud.mark.dto.mark.score.StudentObjectiveAnswerDto;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * 考生归档数据表
 * </p>
 *
 * @author xf
 * @since 2025-03-21
 */
@TableName("mark_archive_student")
@ApiModel(value="MarkArchiveStudent对象", description="考生归档数据表")
public class MarkArchiveStudent implements Serializable {

    private static final long serialVersionUID = 1L;

    @TableId(value = "student_id", type = IdType.INPUT)
    private Long studentId;

    private Long examId;

    private String paperNumber;

    private String studentCode;

    private Long basicStudentId;

    @ApiModelProperty(value = "图片地址")
    private String sheetUrls;

    private String subjectiveQuestions;

    private String objectiveQuestions;

    private String cardContent;

    private Long createTime;

    public Long getStudentId() {
        return studentId;
    }

    public void setStudentId(Long studentId) {
        this.studentId = studentId;
    }
    public Long getExamId() {
        return examId;
    }

    public void setExamId(Long examId) {
        this.examId = examId;
    }
    public String getPaperNumber() {
        return paperNumber;
    }

    public void setPaperNumber(String paperNumber) {
        this.paperNumber = paperNumber;
    }
    public String getStudentCode() {
        return studentCode;
    }

    public void setStudentCode(String studentCode) {
        this.studentCode = studentCode;
    }
    public Long getBasicStudentId() {
        return basicStudentId;
    }

    public void setBasicStudentId(Long basicStudentId) {
        this.basicStudentId = basicStudentId;
    }
    public String getSheetUrls() {
        return sheetUrls;
    }

    public void setSheetUrls(String sheetUrls) {
        this.sheetUrls = sheetUrls;
    }
    public String getSubjectiveQuestions() {
        return subjectiveQuestions;
    }

    public void setSubjectiveQuestions(String subjectiveQuestions) {
        this.subjectiveQuestions = subjectiveQuestions;
    }
    public String getObjectiveQuestions() {
        return objectiveQuestions;
    }

    public void setObjectiveQuestions(String objectiveQuestions) {
        this.objectiveQuestions = objectiveQuestions;
    }
    public String getCardContent() {
        return cardContent;
    }

    public void setCardContent(String cardContent) {
        this.cardContent = cardContent;
    }
    public Long getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Long createTime) {
        this.createTime = createTime;
    }

    @Override
    public String toString() {
        return "MarkArchiveStudent{" +
            "studentId=" + studentId +
            ", examId=" + examId +
            ", paperNumber=" + paperNumber +
            ", studentCode=" + studentCode +
            ", basicStudentId=" + basicStudentId +
            ", sheetUrls=" + sheetUrls +
            ", subjectiveQuestions=" + subjectiveQuestions +
            ", objectiveQuestions=" + objectiveQuestions +
            ", cardContent=" + cardContent +
            ", createTime=" + createTime +
        "}";
    }
}
