package com.qmth.teachcloud.mark.service;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.IService;
import com.qmth.teachcloud.mark.dto.mark.SpecialTagDTO;
import com.qmth.teachcloud.mark.dto.mark.manage.MarkManageDto;
import com.qmth.teachcloud.mark.dto.mark.manage.MarkTaskDto;
import com.qmth.teachcloud.mark.dto.mark.manage.Task;
import com.qmth.teachcloud.mark.dto.mark.manage.TrackDTO;
import com.qmth.teachcloud.mark.entity.MarkTask;
import com.qmth.teachcloud.mark.enums.MarkTaskStatus;
import com.qmth.teachcloud.mark.params.MarkResultQuestion;

import javax.servlet.http.HttpServletResponse;
import java.util.List;

/**
 * <p>
 * 评卷任务表 服务类
 * </p>
 *
 * @author xf
 * @since 2023-09-22
 */
public interface MarkTaskService extends IService<MarkTask> {

    IPage<MarkManageDto> listPaperManage(Long examId, Long openCollegeId, Long courseId, String paperNumber, Boolean progressStatus, Integer pageNumber, Integer pageSize);

    void exportMarker(Long examId, Long courseId, String paperNumber, HttpServletResponse response);

    List<MarkTask> listByExamIdAndPaperNumberAndQuestionIdAndUserIdAndClassName(Long examId, String paperNumber, Long questionId, Long userId, String className);

    Integer markedCount(List<MarkTask> groupNumberMarkTask);

    int countByExamIdAndPaperNumberAndQuestionIdAndUserId(Long examId, String paperNumber, Long questionId, Long userId);

    List<MarkTask> listByExamIdAndPaperNumberAndQuestionIdAndUserIdAndStatusNotIn(Long examId, String paperNumber, Long questionId, Long userId, List<MarkTaskStatus> statusList);

    boolean resetById(Long markTaskId, Long userId, String rejectReason, Long rejectId, Long date, MarkTaskStatus newStatus);

    int countByExamIdAndPaperNumberAndQuestionIdAndStatusIn(Long examId, String paperNumber, Long questionId, List<MarkTaskStatus> statusList);

    int countByExamIdAndPaperNumberAndStatusIn(Long examId, String paperNumber, List<MarkTaskStatus> statusList);

    MarkTask getLastOneByUserIdAndStatus(Long examId, String paperNumber, Long questionId, Long userId, MarkTaskStatus status);

    List<MarkTask> listByExamIdAndPaperNumberAndQuestionIdAndStudentId(Long examId, String paperNumber, Long questionId, Long studentId);

    List<MarkTask> listByStudentIdAndQuestionId(Long studentId, Long questionId);

    void updateHeaderResult(Long examId, String paperNumber, Long questionId, Long studentId, Long updateUserId, Double markerScore, TrackDTO[] tracks, SpecialTagDTO[] specialTags, Long updateTime, MarkTaskStatus arbitrated);

    void deleteByStudentId(Long studentId);

    void deleteByExamIdAndPaperNumberAndQuestionId(Long examId, String paperNumber, Long questionId);

    int countByExamIdAndPaperNumberAndQuestionIdAndAndClassNameStatusIn(Long examId, String paperNumber, Long questionId, List<String> className, MarkTaskStatus... status);

    int countByExamIdAndPaperNumberAndUserIdAndAndClassNameAndQuestionIdIn(Long examId, String paperNumber,Long userId, List<String> className, List<Long> questionIds, MarkTaskStatus... status);

    IPage<MarkTask> listPageHistory(Page<Long> page, Long userId, Long examId, String paperNumber, String secretNumber, Double markerScore, MarkTaskStatus...statuses);

    List<MarkTask> findUnMarked(Page<MarkTask> page, Long examId, String paperNumber, Long userId);

    List<MarkTask> findUnMarkedFilterClass(Page<MarkTask> page, Long examId, String paperNumber, Long userId, Long questionId, List<String> classNames);

    int countByIdAndStatus(Long studentId, MarkTaskStatus status);

    int countByStatusAndIdIn(List<Long> ids, MarkTaskStatus... status);

    List<MarkTask> findByStudentIdAndQuestionIdAndStatus(Long studentId, Long questionId, MarkTaskStatus... status);

    boolean updateProblemResult(Long taskId, Long userId, Long now, int spent);

    boolean updateStatusByStudentIdAndQuestionId(Long studentId, Long questionId, MarkTaskStatus status);

    int countByStudentIdAndMarkerIdAndIdNotEqual(Long studentId, Long examId, String paperNumber, Long questionId, Long userId, Long taskId);

    boolean updateMarkerResult(Long taskId, MarkTaskStatus marked, Long userId, MarkResultQuestion result,
                               Long now, MarkTaskStatus... inStatus);

    int countByExamIdAndPaperNumberAndQuestionIdAndTaskNumber(Long examId, String paperNumber, Long questionId, int taskNumber);

    int countByStudentId(Long studentId);

    int countByExamIdAndPaperNumber(Long examId, String paperNumber);

    IPage<MarkTaskDto> pageMarkTask(Long examId, String paperNumber, Long questionId, String loginName, MarkTaskStatus status, String studentCode, String secretNumber, String teachClassName, Double subScore, Integer pageNumber, Integer pageSize);

    void rejectMarkTask(Long id, String rejectReason);

    Task getMarkTrack(Long id);

    MarkManageDto selectMarkedCountAndTotalCount(Long examId, String paperNumber);

    List<MarkTask> listByStudentId(Long studentId);

    Long minQuestionIdByExamIdAndPaperNumber(Long examId, String paperNumber, MarkTaskStatus... statuses);

    List<MarkTask> listByStudentIdAndUserId(Long studentId, Long userId);

    List<MarkTask> listByStudentIdAndMarkerId(Long studentId, Long markerId, List<MarkTaskStatus> markTaskStatuses);

    void resetHeaderByStudentIdAndQuestionId(Long studentId, Long questionId);

    void resetArbitrateStatusByStudentIdAndQuestionIdAndTaskNumber(Long studentId, Long questionId, Integer taskNumber);
}
